/**
 * @name suns.js
 * @author Kazuma MISHIMAGI <mishimagi_kazuma@cyberagent.co.jp>
 * copyright (c) Cyberagent Inc.
 * @overview Object extending utilities for node and browser (amd support)
 */

/**
 * @name bucks.js
 * @author Kazuma MISHIMAGI <mishimagi_kazuma@cyberagent.co.jp>
 * copyright (c) Cyberagent Inc.
 * @overview Async chain utility for node and the browser. (amd support)
 */

/**
 * @name logcafe.js
 * @author Kei Funagayama <funagayama_kei@cyberagent.co.jp>
 * copyright (c) Cyberagent Inc.
 * @overview browser logging.
 */

/**
 * @license beez Copyright (c) Cyberagent Inc.
 * Available via the MIT License.
 */

!function(t){"use strict";var r=Array.prototype.forEach,e={},n=function(t,n,i){if(void 0!==t&&null!==t)if(r&&t.forEach===r)t.forEach(n,i);else if(t.length===+t.length){for(var o=0,s=t.length;s>o;o++)if(n.call(i,t[o],o,t)===e)return}else for(var u in t)if(Object.prototype.hasOwnProperty.call(t,u)&&n.call(i,t[u],u,t)===e)return},i=function(t){return n(Array.prototype.slice.call(arguments,1),function(r){for(var e in r)t[e]=r[e]}),t},o=/__(super)+__/,s=function(t,r,e){var n;if("object"!=typeof e)throw new Error("typeof childCtorOrProto invalid. it should be Object (prototype object).");n=e&&Object.prototype.hasOwnProperty.call(e,"constructor")?e.constructor:new Function("parent","return function "+t+"(){ parent.apply(this, arguments); };")(r),i(n,r);var s=function(){this.constructor=n};s.prototype=r.prototype,n.prototype=new s,e&&i(n.prototype,e);for(var u in r)if(o.test(u)){var c=u.replace("super","supersuper");n[c]=r[u]}return n.__super__=r.prototype,n.__superCtor__=r,n},u=function d(t,r,e){if(e.length<1)return r;var n=e.shift(),i=s(t,r,n);return d(t,i,e)},c=function(t){var r="",e=Array.prototype.slice.apply(arguments);return"string"==typeof e[0]&&(r=e.shift(),r=r.replace(/\./g,"_")),t=e.shift(),u(r,t,e)},a=function(){var t=this,r=Array.prototype.slice.apply(arguments),e=[];return"string"==typeof r[0]&&e.push(r.shift()),e.push(t),e=e.concat(r),c.apply(this,e)},l=function(t,r,e){var n,s,u=typeof e;if("function"===u)s=e.prototype;else{if("object"!==u)throw new Error("typeof childCtorOrProto invalid. it should be Function or Object.");s=e}n="function"===u?new Function("parent, childCtor","return function "+t+"(){ parent.apply(this, arguments); childCtor.apply(this, arguments)};")(r,e):s&&Object.prototype.hasOwnProperty.call(s,"constructor")?s.constructor:new Function("parent","return function "+t+"(){ parent.apply(this, arguments); };")(r),i(n,r);var c=function(){this.constructor=n};c.prototype=r.prototype,n.prototype=new c,s&&i(n.prototype,s);for(var a in r)if(o.test(a)){var l=a.replace("super","supersuper");n[l]=r[a]}return n.__super__=r.prototype,n.__superCtor__=r,n},h=function g(t,r,e){if(e.length<1)return r;var n=e.shift(),i=l(t,r,n);return g(t,i,e)},f=function(t){var r="",e=Array.prototype.slice.apply(arguments);return"string"==typeof e[0]&&(r=e.shift(),r=r.replace(/\./g,"_")),t=e.shift(),h(r,t,e)},p={extend:c,extendThis:a,mixin:f,VERSION:"0.4.6"};"function"==typeof define&&define.amd?define("beez-core/suns",["require","exports","module"],function(){return p}):"undefined"!=typeof module&&module.exports?module.exports=p:t.suns=p}(this),function(){define("beez-core/error",["require","exports","module","beez-core/suns"],function(t){"use strict";var r=t("beez-core/suns"),e=r.extend("beez.Error",Error,{constructor:function(t){Error.apply(this,arguments),Error.captureStackTrace(this,this.constructor),this.message=t}});return e.extend=r.extendThis,e})}(this),function(t){"use strict";var r=function(){},e=Array.isArray||function(t){return"[object Array]"===t.toString()},n=function(t){return 0===t.length},i=function(t){console.error(t.stack?t.stack:t.message?t.message:t)},o=0,s=function(){return"__bucks__"+o++},u=function a(t){this._tasks=[],this._taskcount=0,this._results=[],this.callback=r,this.failure=r,this._alive=!0,this._interrupt=!1,this.__id=s(),a.living[this.__id]=this,this.initialize(t)};u.VERSION="0.8.4",u.DEBUG=!1,u.running={},u.living={},u._isOnError=!1,u.onError=function l(l){!function(t){u._onError=l,u._isOnError=t}(!0)},u.prototype={initialize:r,_normalizeTask:function(t){var r=t;if(t.length<3)r=function(r,e,n){var i=t.call(null,r,e);n.call(null,null,i)};else if(3===t.length)r=t;else{if(4!==t.length)throw new Error("args length invalid");r=function(r,e,n,i){t.call(null,r,e,n,i)}}return r},_normalizeSuccess:function(t){var r=t;if(t.length<2)r=function(r,e){var n=t(r);e(null,n)};else{if(2!==t.length)throw new Error("args length invalid");r=t}return r},_normalizeError:function(t){var r=t;if(t.length<2||3<t.length)throw new Error(t.name+": args length invalid. should be: onError(err, next)");return r},add:function(t){if(!this._alive)throw new Error("this bucks object already destroyed.");var r=this._normalizeTask(t);return this._tasks.push(r),this},then:function(t){var r=this._normalizeSuccess(t);return this.add(function(t,e,n){t?n(t):r(e,n)})},empty:function(){return this.then(function(){})},error:function(t){var r=this._normalizeError(t);return this.add(function(t,e,n){t?r(t,n):n(t,e)})},_iterator:function(t,r){if(this._interrupt)return this;if(!this._alive)throw new Error("this bucks object already destroyed.");this._results.push(r?r:null);var e=this._tasks.shift();if(!e)return this.destroy(t);try{var n=this;e(t,r,function(t,r){return n._iterator(t,r),this},this._taskcount++)}catch(o){if(!this._results){if(u.DEBUG&&i(o),!u._isOnError)throw o;u._onError(o,this)}this._iterator(o,null)}return this},debug:function(){return this},parallel:function(t){if(!e(t))throw new Error("tasks is not array.");if(n(t))return this.add(function(t,r,e){e(null,new c(0).resultObj)});for(var r=0,i=t.length;i>r;r++){var o=t[r];t[r]=this._normalizeTask(o)}return this.add(function(r,e,n){var i=new c(t.length);i.onFinish(function(t){for(var r,e=0,i=t.err.length;i>e;e++){var o=t.err[e];void 0!==o&&null!==o&&(r=o)}n(r,t)}),t.forEach(function(t,r){setTimeout(function(){(new u).add(t).end(function(t,e){t?i.successOne(r,t,null):i.successOne(r,null,e[0])})},0)})})},waterfall:function(t){if(!e(t))throw new Error("tasks is not array.");if(n(t))return this.add(function(t,r,e){e(null,[])});for(var r=0,i=t.length;i>r;r++)t[r]=this._normalizeTask(t[r]),this.add(t[r]);return this},delay:function(t){return this.add(function(r,e,n){setTimeout(function(){n(r,e)},t||0)})},dispose:r,interrupt:function(){return this._interrupt=!0,this.destroy(),this},destroy:function(t){if(!this._alive)return this;var e=this._results,n=this.callback,o=this.failure,s=this.dispose;this._tasks=null,this._taskcount=0,this._results=null,this.callback=r,this.failure=r,this.dispose=r,e.shift();try{if(n)n(t,e);else if(t)throw t}catch(c){if(o)try{o(c)}catch(a){if(!u._isOnError)throw a;u._onError(a,this)}else{if(u.DEBUG&&i(c),!u._isOnError)throw c;u._onError(c,this)}}finally{try{s.call(this)}catch(a){if(!u._isOnError)throw a;u._onError(a,this)}delete this._alive,delete u.running[this.__id],delete u.living[this.__id],delete this.__id}return this},end:function(t,r){if(t&&t.length<1)throw new Error("callback args length invalid. should be `callback(err, ress)` or `callback(err)`.");if(this.callback=t,this.failure=r,!this._tasks||!this._tasks.length){var e=new Error("task is empty. add(task) first. if theres no task to execute but end is desired, empty() may be useful");return this.destroy(e,null),t(e)}return u.running[this.__id]=this,void this._iterator()}};var c=function(t){this._results=[],this._errors=[],this._waiting=t};c.prototype={onFinish:function(t){this._onFinish=t},successOne:function(t,r,e){this._errors[t]=r,this._results[t]=e,this._waiting--,this._waiting<=0&&this._onFinish.call(null,this.resultObj)}},c.prototype.__defineGetter__("resultObj",function(){return{err:this._errors,res:this._results}}),"function"==typeof define&&define.amd?define("beez-core/bucks",["require","exports","module"],function(){return u}):"undefined"!=typeof module&&module.exports?module.exports=u:t.Bucks=u}(this),function(t){"use strict";var r=function(){},e=function(t,r){this.initialize(t,r)};e.prototype={initialize:function(t,e){this.category=t,this.config=e,this.level=this.config.level,this.config.separator&&(this.separator=this.config.separator||" "),this.level===this.LEVELS.TRACE||(this.level===this.LEVELS.DEBUG?this.trace=r:this.level===this.LEVELS.INFO?this.trace=this.debug=r:this.level===this.LEVELS.WARN?this.trace=this.debug=this.info=r:this.level===this.LEVELS.ERROR&&(this.trace=this.debug=this.info=this.warn=r))},LEVELS:{OFF:"OFF",TRACE:"TRACE",DEBUG:"DEBUG",INFO:"INFO",WARN:"WARN",ERROR:"ERROR"},_exclude:function(){if(this.config.excludes&&0<this.config.excludes.length)for(var t=0;t<this.config.excludes.length;t++){var r=new RegExp("^"+this.config.excludes[t]);if(this.category.match(r))return!0}return!1},trace:function(){!this._exclude()&&console.debug(this.output("trace",arguments))},debug:function(){!this._exclude()&&console.debug(this.output("debug",arguments))},info:function(){!this._exclude()&&console.info(this.output("info",arguments))},warn:function(){!this._exclude()&&console.warn(this.output("warn",arguments))},error:function(){!this._exclude()&&console.error(this.output("error",arguments))},output:function(t,r){for(var e=Array.prototype.slice.call(r),n=0;n<e.length;n++)if(void 0===e[n])e[n]='"undefined"';else if(null===e[n])e[n]='"null"';else if(e[n]instanceof Error||"Error"===e[n].constructor.name){var i=e[n];e[n]=i.stack?i.stack:i.message}else"object"==typeof e[n]&&(e[n]=e[n].constructor.name+":"+JSON.stringify(e[n]));var o,s,u,c="",a=(new Error).stack;return a&&(o=a.split("\n"),o[3]?(s=o[3],u=s.indexOf("("),u>=0?(c=s.substring(u),")"!==c.charAt(c.length-1)&&(c="("+c+")")):c="("+s.replace(/[ ]*at /,"")+")"):o[2]&&(s=o[2],u=s.indexOf("@"),u>=0&&(c=s.substring(u+1),c=" ("+c+")"))),"["+t+"]["+this.category+"] "+e.join(this.separator)+" "+c}};var n=function(t){this.initialize(t)};n.prototype={initialize:function(t){this.config=t,this.loggers={}},setConfigure:function(t){return this.config=t,this},getLogger:function(t){return this.loggers[t]?this.loggers[t]:(this.loggers[t]=new e(t,this.config),this.loggers[t])}},n.VERSION="0.6.7","function"==typeof define&&define.amd?define("beez-core/logcafe",["require","exports","module"],function(){return n}):"undefined"!=typeof module&&module.exports?module.exports=n:t.LogCafe=n}(this),function(t){define("beez.core",["require","exports","module","beez-core/suns","beez-core/error","beez-core/bucks","beez-core/logcafe","backbone","handlebars"],function(r,e,n){"use strict";var i=t;if(i.beez)return i.beez;var o=r("beez-core/suns"),s=n.config()||{},u=r("beez-core/error"),c=r("beez-core/bucks");c.extend=o.extendThis;var a=r("beez-core/logcafe"),l=new a;l.setConfigure(s.logging||{level:"WARN",separator:" "});var h=function(t){return l.getLogger(t)},f=h("beez.core.index"),p=function(r,e,n){r&&(t.onerror=r),e&&c.onError(e),n&&(t.require.onError=n)},d={};if(s.defines&&(d=s.defines,d.globals))for(var g in d.globals)t[g]=d.globals[g],f.debug("Set the value to the global scope.",g,":",t[g]);var _={vendor:{},root:i,global:i,config:s,defines:d,none:function(){},extend:o.extend,extendThis:o.extendThis,mixin:o.mixin,getLogger:h,onError:p,Error:u,Bucks:c};return _.vendor._=_.root._,_.vendor.$=_.root.$,_.vendor.Backbone=r("backbone"),_.vendor.Handlebars=r("handlebars"),i.beez=_,_})}(this);